﻿using COA.PartnerApis.QuickBase;
using System;
using System.Collections.Generic;
using System.Linq.Expressions;

namespace COA.EnterpriseServices.DataAccess.QuickBase
{
    public class QuickBaseDataAccess<T> : IDataAccess<T> where T : class, IRecord, new()
    {
        private readonly QuickBaseApiClient client;

        public QuickBaseDataAccess(QuickBaseApiClient client)
        {
            this.client = client;
        }

        public bool Add(T item)
        {
            var fieldData = FieldMapRegistry.GetTableContext(item);

            var result = client.AddRecord(fieldData.Table, fieldData.FieldIds);

            return result.Success;
        }

        public bool Update(T item)
        {
            var fieldData = FieldMapRegistry.GetTableContext(item);

            var result = client.EditRecord(item.Id, fieldData.Table, fieldData.FieldIds);

            return result.Success;
        }

        public ICollection<T> Get(Expression<Func<T, bool>> query)
        {
            // we'll never get data from QB
            return null;
        }
    }
}
